﻿#region Script Author Information
$script:ScriptName = "Update Archive DB to Fix issues with stored proce usysr_RptUserSAll and tblrptRptUser"
$script:ScriptVersion = "1.0.0.0"
$script:ScriptDate = "September 12, 2019"
$script:ScriptAuthor = "BLUE LANCE"
$script:ScriptAuthorEmail = [System.Text.Encoding]::ASCII.GetString([System.Convert]::FromBase64String("Z2VvZmZyZXlAZ3V5bm4ub3Jn"))
#endregion Script Author Information

#region Script Configuration Variables
$script:WriteMode = $True
#$script:Computers = "$script:WorkingDirectory\computers.txt"
#endregion Script Configuration Variables

#region Script Environment Variables
$script:VerbosePreference = "SilentlyContinue"
$script:DebugPreference = "SilentlyContinue"
$script:WorkingFileName = $MyInvocation.MyCommand.Definition
$script:WorkingDirectory = Split-Path $script:WorkingFileName -Parent


function ShowMessage  {
param ( [string] $message)

$wsh = New-Object -ComObject Wscript.Shell
$wsh.Popup($message)
}

#region Main Thread
try{
   
    $SQLFile = $script:WorkingDirectory + "\Scripts\DBPatch.sql" 

    #Setup SQL Connection
    $SqlConnection = New-Object System.Data.SqlClient.SqlConnection

    #Prompt for database server
    $DatabaseServer = Read-Host 'Enter Database Server Name - Default (localhost)' 
    if ($DatabaseServer -eq "") { $DatabaseServer = 'localhost'}

    #Prompt for LTA Database 
    $LTADatabase = Read-Host 'Enter LT Auditor+ Archive Database Name - Default (LTAArchiveDB)' 
    if ($LTADatabase -eq "") { $LTADatabase = 'LTAArchiveDB'}
    #Prompt for Database Connection
    $ConnectMode = Read-Host 'Authentication [1 - Windows, 2 - SQL] - Default (1)' 
    if (($ConnectMode -ne 2) -and ($ConnectMode -ne 1) ) { $ConnectMode = 1}


    if ($ConnectMode -eq 1) {
        $SqlConnection.ConnectionString = "Server="+$DatabaseServer +";Database="+$LTADatabase+"; Integrated Security=SSPI"
    }
    else {
        $DatabaseUser = Read-Host 'Enter SQL Login ' 
        $DatabasePassword = Read-Host 'Enter SQL Password' -AsSecureString
        $SqlConnection.ConnectionString = "Server="+$DatabaseServer +";Database="+$LTADatabase+";uid="+$DatabaseUser+";pwd="+[Runtime.InteropServices.Marshal]::PtrToStringAuto([Runtime.InteropServices.Marshal]::SecureStringToBSTR($DatabasePassword))
    }

    #Write-Host 'Testing database connection... '
    try
    {
        $SqlConnection.Open()
        Write-Output 'Successfully connected to the database'
        $SqlConnection.Close()
    }
    catch
    {
        Throw
    }
    Push-Location

    #Update Database Script
    if ($ConnectMode -eq 1) {
        Invoke-Sqlcmd -ServerInstance $DatabaseServer -Database $LTADatabase -InputFile $SQLFile 
    } 
    else {
 
        #Invoke-Sqlcmd -ServerInstance $DatabaseServer -Database $LTADatabase -Username $DatabaseUser -Password $DatabasePassword -InputFile $SQLFile   
        $BSTR = [System.Runtime.InteropServices.Marshal]::SecureStringToBSTR($DatabasePassword)
        $Pwwd = [System.Runtime.InteropServices.Marshal]::PtrToStringAuto($BSTR)   
        Invoke-Sqlcmd -ServerInstance $DatabaseServer -Database $LTADatabase -Username $DatabaseUser  -Password $Pwwd  -InputFile $SQLFile
     }

    Write-Host 'Successfully Applied Archive Database Update'
    ShowMessage -message 'Successfully Applied Archive Database Update'




}
catch {
    Write-Host $Error[0]
    ShowMessage -message $Error[0]

    Exit(1)

}


#endregion Main Thread

